
include("InstanceManager");
include("SupportFunctions");	-- Clamp
include("AnimSidePanelSupport");
include("TabSupport");
include("Civ6Common");
include("PopupDialogSupport");
include("ModalScreen_PlayerYieldsHelper");
include("GameCapabilities");

-- ===========================================================================
--	HUD Launch Bar
--	Controls raising full-screen and "choosers"
-- ===========================================================================

local m_PromotionListInstanceMgr:table	= InstanceManager:new( "PromotionSelectionInstance",	"PromotionSelection",	Controls.DoctrinesScrollPanel );
local m_CompletedPromotionListInstanceMgr:table	= InstanceManager:new( "CompletedPromotionSelectionInstance",	"PromotionSelection",	Controls.DoctrinesScrollPanel );	

-- ===========================================================================
-- DOCTRINES
-- ===========================================================================
function OnOpenDoctrines()
	print(ExposedMembers.DoctrinesScreenStatus);
	LuaEvents.LaunchBar_CloseTechTree();
	LuaEvents.LaunchBar_CloseCivicsTree();
	LuaEvents.LaunchBar_CloseReligionPanel();
	LuaEvents.LaunchBar_CloseGreatWorksOverview();
	LuaEvents.LaunchBar_CloseGreatPeoplePopup();
	m_width, m_height	= UIManager:GetScreenSizeVal();
	if m_width ~= nil then
		if m_width <= 1400 then
			Controls.ButtonInfantryDoctrine:SetSizeX(140);
	
			Controls.ButtonCavalryDoctrine:SetSizeX(140);
			Controls.ButtonReconDoctrine:SetSizeX(140);
			Controls.ButtonRangedDoctrine:SetSizeX(140);
			Controls.ButtonNavalDoctrine:SetSizeX(140);
			Controls.ButtonAirDoctrine:SetSizeX(140);
		
			Controls.ButtonInfantryDoctrine:SetOffsetX(-290);
			Controls.ButtonCavalryDoctrine:SetOffsetX(10);
			Controls.ButtonReconDoctrine:SetOffsetX(-140);
			Controls.ButtonRangedDoctrine:SetOffsetX(160);
			Controls.ButtonNavalDoctrine:SetOffsetX(310);
			Controls.ButtonAirDoctrine:SetOffsetX(460);
		end
		if m_width <= 1200 then
			Controls.ButtonInfantryDoctrine:SetOffsetY(44);
			Controls.ButtonCavalryDoctrine:SetOffsetY(44);
			Controls.ButtonReconDoctrine:SetOffsetY(44);
			Controls.ButtonRangedDoctrine:SetOffsetY(44);
			Controls.ButtonNavalDoctrine:SetOffsetY(44);
			Controls.ButtonAirDoctrine:SetOffsetY(44);
		
			Controls.XPTitleHolder:SetOffsetY(80);
			Controls.DoctrineOverallDescription:SetHide(true);
		end
	end
	if ExposedMembers.DoctrinesScreenStatus == true then
		OnCloseDoctrines();
	else
		ExposedMembers.DoctrinesScreenStatus = true;
		UI.PlaySound("UI_Screen_Open");
		Controls.DoctrineScreen:SetHide(false);
		OnInfantryDoctrine();
	end
end

function OnCloseDoctrines()
	UI.PlaySound("UI_Screen_Close");
	Controls.DoctrineScreen:SetHide(true);
	ExposedMembers.DoctrinesScreenStatus = false;
	m_PromotionListInstanceMgr:ResetInstances();
end
function CloseOutDoctrines()
	Controls.SelectInfantryDoctrine:SetHide(true);
	Controls.SelectReconDoctrine:SetHide(true);
	Controls.SelectCavalryDoctrine:SetHide(true);
	Controls.SelectRangedDoctrine:SetHide(true);
	Controls.SelectNavalDoctrine:SetHide(true);
	Controls.SelectAirDoctrine:SetHide(true);
end
-- DOCTRINE SELECTED

function OnInfantryDoctrine()
	ExposedMembers.DoctrinesTypeStatus = 'Infantry';
	CloseOutDoctrines();
	Controls.SelectInfantryDoctrine:SetHide(false);
	DoctrinesDisplay();
end

function OnCavalryDoctrine()
	ExposedMembers.DoctrinesTypeStatus = 'Cavalry';
	CloseOutDoctrines();
	Controls.SelectCavalryDoctrine:SetHide(false);
	DoctrinesDisplay();
end

function OnReconDoctrine()
	ExposedMembers.DoctrinesTypeStatus = 'Recon';
	CloseOutDoctrines();
	Controls.SelectReconDoctrine:SetHide(false);
	DoctrinesDisplay();
end

function OnRangedDoctrine()
	ExposedMembers.DoctrinesTypeStatus = 'Ranged';
	CloseOutDoctrines();
	Controls.SelectRangedDoctrine:SetHide(false);
	DoctrinesDisplay();
end

function OnNavalDoctrine()
	ExposedMembers.DoctrinesTypeStatus = 'Naval';
	CloseOutDoctrines();
	Controls.SelectNavalDoctrine:SetHide(false);
	DoctrinesDisplay();
end

function OnAirDoctrine()
	ExposedMembers.DoctrinesTypeStatus = 'Air';
	CloseOutDoctrines();
	Controls.SelectAirDoctrine:SetHide(false);
	DoctrinesDisplay();
end
function levelsTotal()

end
function DoctrinesDisplay()
	m_PromotionListInstanceMgr:ResetInstances();
	m_CompletedPromotionListInstanceMgr:ResetInstances();
	m_uiNodes = {};
	doctrineTypeLetter = "";
	numPromotions = 0;
	playerID = Game.GetLocalPlayer();
	infantryDoctrineTotal = 0;
	cavalryDoctrineTotal = 0;
	reconDoctrineTotal = 0;
	rangedDoctrineTotal = 0;
	navalDoctrineTotal = 0;
	airDoctrineTotal = 0;
	local MyGlobalsRef : table = {};
		LuaEvents.GetMyGlobals(MyGlobalsRef);
	if ExposedMembers.doctrineLevelTableEM ~= nil then
					for i, doctrineLevelItem in ipairs(ExposedMembers.doctrineLevelTableEM) do
									rightGroup = true;
									for j, doctrineLevelItem in ipairs(doctrineLevelItem) do
											
											if j == 1 and (doctrineLevelItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											-- Looping through all ArmyUnits
											if j == 2 and rightGroup then
												infantryDoctrineTotal = infantryDoctrineTotal + doctrineLevelItem;
											end
											if j == 3 and rightGroup then
												infantryDoctrineTotal = infantryDoctrineTotal + doctrineLevelItem;
											end
											if j == 4 and rightGroup then
												infantryDoctrineTotal = infantryDoctrineTotal + doctrineLevelItem;
											end
											if j == 5 and rightGroup then
												cavalryDoctrineTotal = cavalryDoctrineTotal + doctrineLevelItem;
											end
											if j == 6 and rightGroup then
												cavalryDoctrineTotal = cavalryDoctrineTotal + doctrineLevelItem;
											end
											if j == 7 and rightGroup then
												cavalryDoctrineTotal = cavalryDoctrineTotal + doctrineLevelItem;
											end
											if j == 8 and rightGroup then
												reconDoctrineTotal = reconDoctrineTotal + doctrineLevelItem;
											end
											if j == 9 and rightGroup then
												reconDoctrineTotal = reconDoctrineTotal + doctrineLevelItem;
											end
											if j == 10 and rightGroup then
												reconDoctrineTotal = reconDoctrineTotal + doctrineLevelItem;
											end
											if j == 11 and rightGroup then
												rangedDoctrineTotal = rangedDoctrineTotal + doctrineLevelItem;
											end
											if j == 12 and rightGroup then
												rangedDoctrineTotal = rangedDoctrineTotal + doctrineLevelItem;
											end
											if j == 13 and rightGroup then
												rangedDoctrineTotal = rangedDoctrineTotal + doctrineLevelItem;
											end
											if j == 14 and rightGroup then
												navalDoctrineTotal = navalDoctrineTotal + doctrineLevelItem;
											end
											if j == 15 and rightGroup then
												navalDoctrineTotal = navalDoctrineTotal + doctrineLevelItem;
											end
											if j == 16 and rightGroup then
												navalDoctrineTotal = navalDoctrineTotal + doctrineLevelItem;
											end
											if j == 17 and rightGroup then
												airDoctrineTotal = airDoctrineTotal + doctrineLevelItem;
											end
											if j == 18 and rightGroup then
												airDoctrineTotal = airDoctrineTotal + doctrineLevelItem;
											end
											if j == 19 and rightGroup then
												airDoctrineTotal = airDoctrineTotal + doctrineLevelItem;
											end
									end								
					end
	end
	infantryDoctrineCost = (infantryDoctrineTotal + 1) * 50 + (infantryDoctrineTotal * 60);
	cavalryDoctrineCost = (cavalryDoctrineTotal + 1) * 50 + (cavalryDoctrineTotal * 60);
	reconDoctrineCost = (reconDoctrineTotal + 1) * 50 + (reconDoctrineTotal * 60);
	rangedDoctrineCost = (rangedDoctrineTotal + 1) * 50 + (rangedDoctrineTotal * 60);
	navalDoctrineCost = (navalDoctrineTotal + 1) * 50 + (navalDoctrineTotal * 60);
	airDoctrineCost = (airDoctrineTotal + 1) * 50 + (airDoctrineTotal * 60);
	xpDisplay(infantryDoctrineCost, cavalryDoctrineCost, reconDoctrineCost, rangedDoctrineCost, navalDoctrineCost, airDoctrineCost);

	if ExposedMembers.DoctrinesTypeStatus == 'Infantry' then
		doctrineTypeLetter = "I";
	end
	if ExposedMembers.DoctrinesTypeStatus == 'Cavalry' then
		doctrineTypeLetter = "C";
	end
	if ExposedMembers.DoctrinesTypeStatus == 'Recon' then
		doctrineTypeLetter = "S";
	end
	if ExposedMembers.DoctrinesTypeStatus == 'Ranged' then
		doctrineTypeLetter = "R";
	end
	if ExposedMembers.DoctrinesTypeStatus == 'Naval' then
		doctrineTypeLetter = "N";
	end
	if ExposedMembers.DoctrinesTypeStatus == 'Air' then
		doctrineTypeLetter = "A";
	end
	for row in GameInfo.UnitPromotions() do
		promotionType = row.UnitPromotionType;
		validPromotion = false;
		validMilitary = false;
		validDoctrine = false;
		validInfantry = false;
		
		for i = 1, #promotionType do
			local c = promotionType:sub(i,i)
			-- 6th ICON letter should be unique
			if c == "M" and i == 12 then 
				validMilitary = true;
			end
			if c == "D" and i == 13 then 
				validDoctrine = true;
			end  
			if c == doctrineTypeLetter and i == 11 then 
				validInfantry = true;
			end
			if validMilitary and validDoctrine and validInfantry then
				validPromotion = true;
				break;
			end
		end
		if validPromotion == true then
			doctrineTotal = 0;
			m_uiNodes[promotionType] = row;
			print("#Doctrines = " .. promotionType);
			local promotionInstance;
			hasPromotion = false;
			--if hasPromotion then
			--	promotionInstance = m_CompletedPromotionListInstanceMgr:GetInstance();
			--else
			playerID = Game.GetLocalPlayer();
			for i, promotionItem in ipairs(ExposedMembers.promotionTableEM) do
									rightGroup = true;
									print('#Doctrines Looping through Table i');
									for j, promotionItem in ipairs(promotionItem) do
											print('#Doctrines Looping through Table j');
											if j == 1 and (promotionItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
												print('#Doctrines wrong group');
											end
											-- Looping through all ArmyUnits
											if j == 2 and rightGroup and promotionItem == row.UnitPromotionType then
												hasPromotion = true;
												print('#Doctrines has promotion true');
												break;									
											end
									end								
			end
			if hasPromotion then
				promotionInstance = m_CompletedPromotionListInstanceMgr:GetInstance();
			else
				promotionInstance = m_PromotionListInstanceMgr:GetInstance();
			end -- 2* 400-
			if m_width ~= nil then
				if m_width <= 1200 then
					promotionInstance.PromotionSelection:SetOffsetVal(((row.Level - 1) * 352) + 5, (((row.Column - 1) * 200 + 130) + ((row.Level - 1) * (400 - (100 * (row.Level - 2))))));
				elseif m_width >= 1200 and m_width <= 1400 then
					promotionInstance.PromotionSelection:SetOffsetVal(((row.Level - 1) * 352) + 250, (((row.Column - 1) * 200 + 130) + ((row.Level - 1) * (400 - (100 * (row.Level - 2))))));
				else
					promotionInstance.PromotionSelection:SetOffsetVal((row.Level * 352), (((row.Column - 1) * 200 + 130) + ((row.Level - 1) * (400 - (100 * (row.Level - 2))))));
				end
			end
			if m_width == nil then
				promotionInstance.PromotionSelection:SetOffsetVal((row.Level * 352), (((row.Column - 1) * 200 + 130) + ((row.Level - 1) * (400 - (100 * (row.Level - 2))))));
			end
			promotionInstance.PromotionName:SetText(Locale.ToUpper(row.Name));
			promotionInstance.PromotionDescription:SetText(Locale.Lookup(row.Description));
			if row.Level == 1 then
				numPromotions = numPromotions + 1;
			end
			Controls.Background:SetSizeY(numPromotions * 200 + 110);
			--Controls.ArtParchmentRippleBottom:SetOffsetY((numPromotions * 200 + 110) * -1);
			--Controls.ArtParchmentDecoBottom:SetOffsetY((numPromotions * 200 + 110 + 50) * -1);
			--local iconName = "ICON_" .. promotionDefinition.UnitPromotionType;
			--local textureOffsetX, textureOffsetY, textureSheet = IconManager:FindIconAtlas(iconName,32);
			--if (textureOffsetX ~= nil) then
			--	promotionInstance.PromotionIcon:SetTexture( textureOffsetX, textureOffsetY, textureSheet );
			--end
		
			-- Check if available in saved Table
			-- table organized : [playerid, #lvl1 Infantry, #lvl2 Infantry, #lvl3 Infantry etc...] this table needs to save (save in string?)
			-- second table : [playerid, each promotion type...] also needs to save in string?
			if ExposedMembers.doctrineLevelTableEM ~= nil then
					for i, doctrineLevelItem in ipairs(ExposedMembers.doctrineLevelTableEM) do
									rightGroup = true;
									for j, doctrineLevelItem in ipairs(doctrineLevelItem) do
										
											if j == 1 and (doctrineLevelItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											-- Looping through all ArmyUnits
											if j == 2 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Infantry' and row.Level == 1 then
												infantryLvl1Total = doctrineLevelItem;
												if infantryDoctrineCost <= ExposedMembers.infantryXPTotal and hasPromotion == false then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
													-- save location
													
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
													
												end
												if infantryDoctrineCost <= ExposedMembers.infantryXPTotal then
													Controls.InfantryDoctrineAvailable:SetHide(false);
												else
													Controls.InfantryDoctrineAvailable:SetHide(true);
												end
											end
											if j == 2 and rightGroup then
												if infantryDoctrineCost <= ExposedMembers.infantryXPTotal then
													Controls.InfantryDoctrineAvailable:SetHide(false);
													
												else
													Controls.InfantryDoctrineAvailable:SetHide(true);
												end
												if airDoctrineCost <= ExposedMembers.airXPTotal then
													Controls.AirDoctrineAvailable:SetHide(false);
												else
													Controls.AirDoctrineAvailable:SetHide(true);
												end
												if cavalryDoctrineCost <= ExposedMembers.cavalryXPTotal then
													Controls.CavalryDoctrineAvailable:SetHide(false);
												else
													Controls.CavalryDoctrineAvailable:SetHide(true);
												end
												if reconDoctrineCost <= ExposedMembers.reconXPTotal then
													Controls.ReconDoctrineAvailable:SetHide(false);
												else
													Controls.ReconDoctrineAvailable:SetHide(true);
												end
												if rangedDoctrineCost <= ExposedMembers.rangedXPTotal then
													Controls.RangedDoctrineAvailable:SetHide(false);
												else
													Controls.RangedDoctrineAvailable:SetHide(true);
												end
												if navalDoctrineCost <= ExposedMembers.navalXPTotal then
													Controls.NavalDoctrineAvailable:SetHide(false);
												else
													Controls.NavalDoctrineAvailable:SetHide(true);
												end
												if infantryDoctrineCost <= ExposedMembers.infantryXPTotal or navalDoctrineCost <= ExposedMembers.navalXPTotal or airDoctrineCost <= ExposedMembers.airXPTotal or reconDoctrineCost <= ExposedMembers.reconXPTotal or cavalryDoctrineCost <= ExposedMembers.cavalryXPTotal or rangedDoctrineCost <= ExposedMembers.rangedXPTotal then
													--Controls.DoctrinesAvailableIndicator:SetHide(false);
													--Controls.DoctrinesAvailableIndicator:SetToolTipString("New Doctrine Available!");
												else
													--Controls.DoctrinesAvailableIndicator:SetHide(true);
													--Controls.DoctrinesAvailableIndicator:SetToolTipString();
												end
											end
											if j == 3 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Infantry' and row.Level == 2 then
												infantryLvl2Total = doctrineLevelItem;
												if  infantryLvl1Total >= 2 * (infantryLvl2Total + 1) and infantryDoctrineCost <= ExposedMembers.infantryXPTotal and hasPromotion == false  then
													
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 4 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Infantry' and row.Level == 3 then
												infantryLvl3Total = doctrineLevelItem;
												if infantryLvl2Total >= 2 * (infantryLvl3Total + 1) and infantryDoctrineCost <= ExposedMembers.infantryXPTotal and hasPromotion == false then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 5 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Cavalry' and row.Level == 1  then
												cavalryLvl1Total = doctrineLevelItem;
												if cavalryDoctrineCost <= ExposedMembers.cavalryXPTotal and hasPromotion == false then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
												
											end
											if j == 6 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Cavalry' and row.Level == 2 then
												cavalryLvl2Total = doctrineLevelItem;
												if  cavalryLvl1Total >= 2 * (cavalryLvl2Total + 1) and hasPromotion == false and cavalryDoctrineCost <= ExposedMembers.cavalryXPTotal  then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 7 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Cavalry' and row.Level == 3 then
												cavalryLvl3Total = doctrineLevelItem;
												if cavalryLvl2Total >= 2 * (cavalryLvl3Total + 1) and hasPromotion == false and cavalryDoctrineCost <= ExposedMembers.cavalryXPTotal  then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 8 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Recon' and row.Level == 1 then
												reconLvl1Total = doctrineLevelItem;
												if reconDoctrineCost <= ExposedMembers.reconXPTotal and hasPromotion == false then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
												
											end
											if j == 9 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Recon' and row.Level == 2 then
												reconLvl2Total = doctrineLevelItem;
												if  reconLvl1Total >= 2 * (reconLvl2Total + 1) and hasPromotion == false and reconDoctrineCost <= ExposedMembers.reconXPTotal  then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 10 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Recon' and row.Level == 3 then
												reconLvl3Total = doctrineLevelItem;
												if reconLvl2Total >= 2 * (reconLvl3Total + 1) and hasPromotion == false and reconDoctrineCost <= ExposedMembers.reconXPTotal then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 11 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Ranged' and row.Level == 1 then
												rangedLvl1Total = doctrineLevelItem;
												if rangedDoctrineCost <= ExposedMembers.rangedXPTotal and hasPromotion == false then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
												
											end
											if j == 12 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Ranged' and row.Level == 2 then
												rangedLvl2Total = doctrineLevelItem;
												if  rangedLvl1Total >= 2 * (rangedLvl2Total + 1) and hasPromotion == false and rangedDoctrineCost <= ExposedMembers.rangedXPTotal  then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 13 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Ranged' and row.Level == 3 then
												rangedLvl3Total = doctrineLevelItem;
												if rangedLvl2Total >= 2 * (rangedLvl3Total + 1) and hasPromotion == false and rangedDoctrineCost <= ExposedMembers.rangedXPTotal  then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 14 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Naval' and row.Level == 1 then
												navalLvl1Total = doctrineLevelItem;
												if navalDoctrineCost <= ExposedMembers.navalXPTotal and hasPromotion == false then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
												
											end
											if j == 15 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Naval' and row.Level == 2 then
												navalLvl2Total = doctrineLevelItem;
												print("Naval 1 Total: " .. navalLvl1Total);
												print("Naval 2 Total: " .. navalLvl1Total);
												if  navalLvl1Total >= 2 * (navalLvl2Total + 1) and hasPromotion == false and navalDoctrineCost <= ExposedMembers.navalXPTotal then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 16 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Naval' and row.Level == 3 then
												navalLvl3Total = doctrineLevelItem;
												if navalLvl2Total >= 2 * (navalLvl3Total + 1) and hasPromotion == false and navalDoctrineCost <= ExposedMembers.navalXPTotal  then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 17 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Air' and row.Level == 1 then
												airLvl1Total = doctrineLevelItem;
												if airDoctrineCost <= ExposedMembers.airXPTotal and hasPromotion == false then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
												
											end
											
											if j == 18 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Air' and row.Level == 2 then
												airLvl2Total = doctrineLevelItem;
												if  airLvl1Total >= 2 * (airLvl2Total + 1) and hasPromotion == false and airDoctrineCost <= ExposedMembers.airXPTotal  then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
											if j == 19 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Air' and row.Level == 3 then
												airLvl3Total = doctrineLevelItem;
												if airLvl2Total >= 2 * (airLvl3Total + 1) and hasPromotion == false and airDoctrineCost <= ExposedMembers.airXPTotal then
													promotionInstance.PromotionSlot:SetDisabled(false);
													promotionInstance.PromotionSlot:RegisterCallback( Mouse.eLClick, OnDoctrineClicked );
													promotionInstance.PromotionSlot:SetVoid1( row.Index );
												else
													promotionInstance.PromotionSlot:SetDisabled(true);
												end
											end
									end								
						end
			end
		end
		Controls.DoctrinesScrollPanel:CalculateInternalSize();
	end
end

function xpDisplay(infantryDoctrineCost, cavalryDoctrineCost, reconDoctrineCost, rangedDoctrineCost, navalDoctrineCost, airDoctrineCost)
	playerID = Game.GetLocalPlayer();
	for i, xpItem in ipairs(ExposedMembers.doctrineXPTableEM) do
									rightGroup = true;
									for j, xpItem in ipairs(xpItem) do
											
											if j == 1 and (xpItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											if j == 2 and rightGroup then
												ExposedMembers.infantryXPTotal = xpItem;								
											end
											if j == 3 and rightGroup then
												ExposedMembers.cavalryXPTotal = xpItem;								
											end
											if j == 4 and rightGroup then
												ExposedMembers.reconXPTotal = xpItem;								
											end
											if j == 5 and rightGroup then
												ExposedMembers.rangedXPTotal = xpItem;								
											end
											if j == 6 and rightGroup then
												ExposedMembers.navalXPTotal = xpItem;								
											end
											if j == 7 and rightGroup then
												ExposedMembers.airXPTotal = xpItem;								
											end
											if j == 2 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Infantry' then
												Controls.xpLabel:SetText(xpItem .. " / " .. infantryDoctrineCost .. " xp");	
												ExposedMembers.infantryXPTotal = xpItem;								
											end
											
											if j == 3 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Cavalry' then
												Controls.xpLabel:SetText(xpItem .. " / " .. cavalryDoctrineCost .. " xp");
												ExposedMembers.cavalryXPTotal = xpItem;										
											end
											if j == 4 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Recon' then
												
												Controls.xpLabel:SetText(xpItem .. " / " .. reconDoctrineCost .. " xp");
												ExposedMembers.reconXPTotal = xpItem;										
											end
											if j == 5 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Ranged' then
												Controls.xpLabel:SetText(xpItem .. " / " .. rangedDoctrineCost .. " xp");
												ExposedMembers.rangedXPTotal = xpItem;										
											end
											if j == 6 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Naval' then
												
												Controls.xpLabel:SetText(xpItem .. " / " .. navalDoctrineCost .. " xp");
												ExposedMembers.navalXPTotal = xpItem;										
											end
											if j == 7 and rightGroup and ExposedMembers.DoctrinesTypeStatus == 'Air' then
												Controls.xpLabel:SetText(xpItem .. " / " .. airDoctrineCost .. " xp");
												ExposedMembers.airXPTotal = xpItem;										
											end
											
									end								
					end
end

function OnDoctrineClicked(index)
	for row in GameInfo.UnitPromotions() do
		if index == row.Index then
			promotionType = row.UnitPromotionType;
			classType = row.PromotionClass;
			level = row.Level;
		end
	end
		playerID = Game.GetLocalPlayer();
		print(promotionType);
		print(classType);
		storePromotion(playerID, promotionType, classType);
		addLevelToPlayer(playerID, classType, level);
		DoctrinesDisplay();
end



function storePromotion(playerID, doctrineType, doctrineClass)
		local MyGlobalsRef : table = {};
		LuaEvents.GetMyGlobals(MyGlobalsRef);
		newPromotionTable = {};
		print("#Doctrines Storing Promotion");
		table.insert(newPromotionTable, 1, playerID);
		table.insert(newPromotionTable, 2, doctrineType);
		print(doctrineType);
		table.insert(newPromotionTable, 3, doctrineClass);
		table.insert(ExposedMembers.promotionTableEM, 1, newPromotionTable);

		MyGlobalsRef.MyGlobals.globalPromotionTable = ExposedMembers.promotionTableEM;
		savePromotion();

end

function addLevelToPlayer(playerID, doctrineType, level)
	if ExposedMembers.doctrineXPTableEM ~= nil then
					for i, xpItem in ipairs(ExposedMembers.doctrineLevelTableEM) do
									rightGroup = true;
									for j, xpItem in ipairs(xpItem) do
											if j == 1 and (xpItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											-- Looping through all ArmyUnits
											if j == 2 and rightGroup and doctrineType == 'PROMOTION_CLASS_MELEE' and level == 1 then
												newXP = 0;
												newXP = xpItem + 1;
												print(newXP);
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;
												print("store " .. ExposedMembers.doctrineLevelTableEM[i][j]);										
											end
											if j == 3 and rightGroup and doctrineType == 'PROMOTION_CLASS_MELEE' and level == 2 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;
												print("store " .. ExposedMembers.doctrineLevelTableEM[i][j]);												
											end
											if j == 4 and rightGroup and doctrineType == 'PROMOTION_CLASS_MELEE' and level == 3 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 5 and rightGroup and doctrineType == 'PROMOTION_CLASS_LIGHT_CAVALRY' and level == 1 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;									
											end
											if j == 6 and rightGroup and doctrineType == 'PROMOTION_CLASS_LIGHT_CAVALRY' and level == 2 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;									
											end
											if j == 7 and rightGroup and doctrineType == 'PROMOTION_CLASS_LIGHT_CAVALRY' and level == 3 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;									
											end
											if j == 8 and rightGroup and doctrineType == 'PROMOTION_CLASS_RECON' and level == 1 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 9 and rightGroup and doctrineType == 'PROMOTION_CLASS_RECON' and level == 2 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 10 and rightGroup and doctrineType == 'PROMOTION_CLASS_RECON' and level == 3 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 11 and rightGroup and doctrineType == 'PROMOTION_CLASS_RANGED' and level == 1 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;									
											end
											if j == 12 and rightGroup and doctrineType == 'PROMOTION_CLASS_RANGED' and level == 2 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;									
											end 
											if j == 13 and rightGroup and doctrineType == 'PROMOTION_CLASS_RANGED' and level == 3 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;									
											end
											if j == 14 and rightGroup and doctrineType == 'PROMOTION_CLASS_NAVAL_MELEE' and level == 1 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 15 and rightGroup and doctrineType == 'PROMOTION_CLASS_NAVAL_MELEE' and level == 2 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 16 and rightGroup and doctrineType == 'PROMOTION_CLASS_NAVAL_MELEE' and level == 3 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 17 and rightGroup and doctrineType == 'PROMOTION_CLASS_AIR_FIGHTER' and level == 1 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 18 and rightGroup and doctrineType == 'PROMOTION_CLASS_AIR_FIGHTER' and level == 2 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
											if j == 19 and rightGroup and doctrineType == 'PROMOTION_CLASS_AIR_FIGHTER' and level == 3 then
												newXP = 0;
												newXP = xpItem + 1;
												ExposedMembers.doctrineLevelTableEM[i][j]=newXP;										
											end
									end								
					end
	end
	saveLevelTable();
end

function saveLevelTable()
		savedString = "";
		if ExposedMembers.doctrineLevelTableEM ~= nil then
				for i, xpGroupItem in ipairs(ExposedMembers.doctrineLevelTableEM) do
								-- Looping through All Army Groups
								rightGroup = true;
								savedString = savedString .. "!";
								for j, xpItem in ipairs(xpGroupItem) do
										
										if j == 1 then
											savedString = savedString .. "@" .. xpItem .. "@";
										end
										-- Looping through all ArmyUnits
										if j >= 2 and rightGroup then
											savedString = savedString .. "#" .. xpItem .. "#";
										end
								end
								savedString = savedString .. "!";
					end
			print(savedString);
			GameConfiguration.SetValue ("doctrineLevelTable", savedString);
			doctrineLevelTable = GameConfiguration.GetValue ("doctrineLevelTable");
			print("Level Table: " .. doctrineLevelTable);
		end
end

function savePromotion()
		savedString = "";
		if ExposedMembers.promotionTableEM ~= nil then
				for i, xpGroupItem in ipairs(ExposedMembers.promotionTableEM) do
								-- Looping through All Army Groups
								rightGroup = true;
								savedString = savedString .. "!";
								for j, xpItem in ipairs(xpGroupItem) do
										
										if j == 1 then
											savedString = savedString .. "@" .. xpItem .. "@";
										end
										-- Looping through all ArmyUnits
										if j == 2 and rightGroup then
											savedString = savedString .. "#" .. xpItem .. "#";
										end
										if j == 3 and rightGroup then
											savedString = savedString .. "$" .. xpItem .. "$";
										end
								end
								savedString = savedString .. "!";
					end
			print(savedString);
			GameConfiguration.SetValue ("doctrinePromotionTable", savedString);
			doctrinePromotionTable = GameConfiguration.GetValue ("doctrinePromotionTable");
			print("Level Table: " .. doctrinePromotionTable);
		end
end
-- ===========================================================================


-- ===========================================================================
--	Input
--	UI Event Handler
-- ===========================================================================
function KeyUpHandler( key:number )
	if ExposedMembers.DoctrinesScreenStatus == true then
		if key == Keys.VK_ESCAPE then
			OnCloseDoctrines();
			ExposedMembers.DoctrinesScreenStatus = false;
			return true;
		end
		print(key);
		if key == Keys.X then
			OnCloseDoctrines();
			ExposedMembers.DoctrinesScreenStatus = false;
			return true;
		end
	end
	print(key);
	if key == Keys.X then
		OnOpenDoctrines();
		ExposedMembers.DoctrinesScreenStatus = true;
		return true;
	end
	return false;
end
function OnInputHandler( pInputStruct:table )
	local uiMsg = pInputStruct:GetMessageType();
	if uiMsg == KeyEvents.KeyUp then return KeyUpHandler( pInputStruct:GetKey() ); end	
	return false;
end

-- ===========================================================================
function OnCombat(combatMembers)
		savedString = "";
		if ExposedMembers.doctrineXPTableEM ~= nil then
				for i, xpGroupItem in ipairs(ExposedMembers.doctrineXPTableEM) do
								
								rightGroup = true;
								savedString = savedString .. "!";
								for j, xpItem in ipairs(xpGroupItem) do
										
										if j == 1 then
											savedString = savedString .. "@" .. xpItem .. "@";
										end
										
										if j >= 2 then
											savedString = savedString .. "#" .. xpItem .. "#";
										end
								end
								savedString = savedString .. "!";
					end
			print(savedString);
			GameConfiguration.SetValue ("doctrineXPTable", savedString);
			doctrineXPTable = GameConfiguration.GetValue ("doctrineXPTable");
			print("XP Table: " .. doctrineXPTable);
		end
		DoctrinesDisplay();

end
Events.Combat.Add( OnCombat );

function selectRandomDoctrine(playerID, doctrineTypeLetter, level)
	print("Selecting Random Promotion");
	
	local promotionChosen = false;
	local random_num7 = math.random( 1, 8 );
	local random_num4 = math.random( 1, 4 );
	local random_num2 = math.random( 1, 2 );
	for row in GameInfo.UnitPromotions() do
		local hasPromotion = false;
		for i, promotionItem in ipairs(ExposedMembers.promotionTableEM) do
									rightGroup = true;
									for j, promotionItem in ipairs(promotionItem) do
											if j == 1 and (promotionItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											-- Looping through all ArmyUnits
											if j == 2 and rightGroup and promotionItem == row.UnitPromotionType then
												hasPromotion = true;
												break;									
											end
									end								
		end
		promotionType = row.UnitPromotionType;
		validPromotion = false;
		validMilitary = false;
		validDoctrine = false;
		validInfantry = false;
		
		for i = 1, #promotionType do
			local c = promotionType:sub(i,i)
			-- 6th ICON letter should be unique
			if c == "M" and i == 12 then 
				validMilitary = true;
			end
			if c == "D" and i == 13 then 
				validDoctrine = true;
			end  
			if c == doctrineTypeLetter and i == 11 then 
				validInfantry = true;
			end
			if validMilitary and validDoctrine and validInfantry then
				validPromotion = true;
				break;
			end
		end
		if validPromotion == true then
			print("Valid Promotion");
			print(hasPromotion);
			print(promotionChosen);
			print(level);
			print(row.Level);
			print(row.Column);
			print(random_num7);
			print(random_num2);
			if hasPromotion and (row.Column == random_num4 or row.Column == random_num2 or row.Column == random_num7) then
				print("Already has Promotion: " .. row.UnitPromotionType);
				random_num7 = math.random( 1, 8 );
				random_num4 = math.random( 1, 4 );
				random_num2 = math.random( 1, 2 );
			end
			if row.Level == level and hasPromotion == false and promotionChosen == false then
				print("Matching Level");
				if level == 2 then
					if row.Column == random_num4 then
						storePromotion(playerID, row.UnitPromotionType, row.PromotionClass);
						addLevelToPlayer(playerID, row.PromotionClass, row.Level);
						promotionChosen = true;
					end
				elseif level == 3 then
					if row.Column == random_num2 then
						storePromotion(playerID, row.UnitPromotionType, row.PromotionClass);
						addLevelToPlayer(playerID, row.PromotionClass, row.Level);
						promotionChosen = true;
					end
				else
					if row.Column == random_num7 then
						print("AI Earned Promotion: " .. row.UnitPromotionType);
						storePromotion(playerID, row.UnitPromotionType, row.PromotionClass);
						addLevelToPlayer(playerID, row.PromotionClass, row.Level);
						promotionChosen = true;
					end
				end
			
			end
		end
	end
end

function OnPlayerTurnActivated( playerID, bFirstTime )
		local pPlayer = Players[playerID];
		if (pPlayer:IsMajor() and pPlayer:IsHuman() == false) then
			local infantryDoctrineTotal = 0;
			local cavalryDoctrineTotal = 0;
			local reconDoctrineTotal = 0;
			local rangedDoctrineTotal = 0;
			local navalDoctrineTotal = 0;
			local airDoctrineTotal = 0;
			for i, xpItem in ipairs(ExposedMembers.doctrineXPTableEM) do
									rightGroup = true;
									for j, xpItem in ipairs(xpItem) do
											
											if j == 1 and (xpItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											if j == 2 and rightGroup then
												ExposedMembers.infantryXPTotalAI = xpItem;								
											end
											if j == 3 and rightGroup then
												ExposedMembers.cavalryXPTotalAI = xpItem;								
											end
											if j == 4 and rightGroup then
												ExposedMembers.reconXPTotalAI = xpItem;								
											end
											if j == 5 and rightGroup then
												ExposedMembers.rangedXPTotalAI = xpItem;								
											end
											if j == 6 and rightGroup then
												ExposedMembers.navalXPTotalAI = xpItem;								
											end
											if j == 7 and rightGroup then
												ExposedMembers.airXPTotalAI = xpItem;								
											end
									end								
				end
				for i, doctrineLevelItem in ipairs(ExposedMembers.doctrineLevelTableEM) do
									rightGroup = true;
									for j, doctrineLevelItem in ipairs(doctrineLevelItem) do
										
											if j == 1 and (doctrineLevelItem ~= playerID or playerID == nil) then
												--skip
												rightGroup = false;
											end
											-- Looping through all ArmyUnits
											if j == 2 and rightGroup then
												infantryDoctrineTotal = infantryDoctrineTotal + doctrineLevelItem;
												infantryLvl1Total = doctrineLevelItem;
											end
											if j == 3 and rightGroup then
												infantryDoctrineTotal = infantryDoctrineTotal + doctrineLevelItem;
												infantryLvl2Total = doctrineLevelItem;
											end
											if j == 4 and rightGroup then
												infantryDoctrineTotal = infantryDoctrineTotal + doctrineLevelItem;
												infantryLvl3Total = doctrineLevelItem;
											end
											
											if j == 4 and rightGroup then
												infantryDoctrineCost = (infantryDoctrineTotal + 1) * 30 + (infantryDoctrineTotal * 20);
												print("Doctrine Total: " .. infantryDoctrineTotal);
												print("Doctrine Cost: " .. infantryDoctrineCost);
												print("Doctrine Total lvl 1: " .. infantryLvl1Total);
												print("Doctrine Total lvl 2: " .. infantryLvl2Total);
												print("Doctrine Total lvl 3: " .. infantryLvl3Total);
												if infantryDoctrineCost <= ExposedMembers.infantryXPTotalAI then
													if  infantryLvl1Total >= 2 * (infantryLvl2Total + 1) then
														selectRandomDoctrine(playerID, 'I', 2);
													elseif infantryLvl2Total >= 2 * (infantryLvl3Total + 1) then
														selectRandomDoctrine(playerID, 'I', 3);
													else
														selectRandomDoctrine(playerID, 'I', 1);
													end
												end
											
											end
											if j == 5 and rightGroup then
												cavalryDoctrineTotal = cavalryDoctrineTotal + doctrineLevelItem;
												cavalryLvl1Total = doctrineLevelItem;
											end
											if j == 6 and rightGroup then
												cavalryDoctrineTotal = cavalryDoctrineTotal + doctrineLevelItem;
												cavalryLvl2Total = doctrineLevelItem;
											end
											if j == 7 and rightGroup then
												cavalryDoctrineTotal = cavalryDoctrineTotal + doctrineLevelItem;
												cavalryLvl3Total = doctrineLevelItem;
											end
											
											if j == 7 and rightGroup then
												cavalryDoctrineCost = (cavalryDoctrineTotal + 1) * 30 + (cavalryDoctrineTotal * 20);
												if cavalryDoctrineCost <= ExposedMembers.cavalryXPTotalAI then
													if  cavalryLvl1Total >= 2 * (cavalryLvl2Total + 1) and cavalryDoctrineCost <= ExposedMembers.cavalryXPTotal then
														selectRandomDoctrine(playerID, 'C', 2);
													elseif cavalryLvl2Total >= 2 * (cavalryLvl3Total + 1) and cavalryDoctrineCost <= ExposedMembers.cavalryXPTotal then
														selectRandomDoctrine(playerID, 'C', 3);
													else
														selectRandomDoctrine(playerID, 'C', 1);
													end
												end
											
											end
											if j == 8 and rightGroup then
												reconDoctrineTotal = reconDoctrineTotal + doctrineLevelItem;
												reconLvl1Total = doctrineLevelItem;
											end
											if j == 9 and rightGroup then
												reconDoctrineTotal = reconDoctrineTotal + doctrineLevelItem;
												reconLvl2Total = doctrineLevelItem;
											end
											if j == 10 and rightGroup then
												reconDoctrineTotal = reconDoctrineTotal + doctrineLevelItem;
												reconLvl3Total = doctrineLevelItem;
											end
											
											if j == 10 and rightGroup then
												reconDoctrineCost = (reconDoctrineTotal + 1) * 30 + (reconDoctrineTotal * 20);
												if reconDoctrineCost <= ExposedMembers.reconXPTotalAI then
													if  reconLvl1Total >= 2 * (reconLvl2Total + 1) then
														selectRandomDoctrine(playerID, 'S', 2);
													elseif reconLvl2Total >= 2 * (reconLvl3Total + 1) then
														selectRandomDoctrine(playerID, 'S', 3);
													else
														selectRandomDoctrine(playerID, 'S', 1);
													end
												end
											
											end
											if j == 11 and rightGroup then
												rangedDoctrineTotal = rangedDoctrineTotal + doctrineLevelItem;
												rangedLvl1Total = doctrineLevelItem;
											end
											if j == 12 and rightGroup then
												rangedDoctrineTotal = rangedDoctrineTotal + doctrineLevelItem;
												rangedLvl2Total = doctrineLevelItem;
											end
											if j == 13 and rightGroup then
												rangedDoctrineTotal = rangedDoctrineTotal + doctrineLevelItem;
												rangedLvl3Total = doctrineLevelItem;
											end
											
											if j == 13 and rightGroup then
												rangedDoctrineCost = (rangedDoctrineTotal + 1) * 30 + (rangedDoctrineTotal * 20);
												if rangedDoctrineCost <= ExposedMembers.rangedXPTotalAI then
													if  rangedLvl1Total >= 2 * (rangedLvl2Total + 1) then
														selectRandomDoctrine(playerID, 'R', 2);
													elseif rangedLvl2Total >= 2 * (rangedLvl3Total + 1) then
														selectRandomDoctrine(playerID, 'R', 3);
													else
														selectRandomDoctrine(playerID, 'R', 1);
													end
												end
											
											end
											if j == 14 and rightGroup then
												navalDoctrineTotal = navalDoctrineTotal + doctrineLevelItem;
												navalLvl1Total = doctrineLevelItem;
											end
											if j == 15 and rightGroup then
												navalDoctrineTotal = navalDoctrineTotal + doctrineLevelItem;
												navalLvl2Total = doctrineLevelItem;
											end
											if j == 16 and rightGroup then
												navalDoctrineTotal = navalDoctrineTotal + doctrineLevelItem;
												navalLvl3Total = doctrineLevelItem;
											end
											
											if j == 16 and rightGroup then
												navalDoctrineCost = (navalDoctrineTotal + 1) * 30 + (navalDoctrineTotal * 20);
												if navalDoctrineCost <= ExposedMembers.navalXPTotalAI then
													if  navalLvl1Total >= 2 * (navalLvl2Total + 1) then
														selectRandomDoctrine(playerID, 'N', 2);
													elseif navalLvl2Total >= 2 * (navalLvl3Total + 1) then
														selectRandomDoctrine(playerID, 'N', 3);
													else
														selectRandomDoctrine(playerID, 'N', 1);
													end
												end
											
											end
											if j == 17 and rightGroup then
												airDoctrineTotal = airDoctrineTotal + doctrineLevelItem;
												airLvl1Total = doctrineLevelItem;
											end
											if j == 18 and rightGroup then
												airDoctrineTotal = airDoctrineTotal + doctrineLevelItem;
												airLvl2Total = doctrineLevelItem;
											end
											if j == 19 and rightGroup then
												airDoctrineTotal = airDoctrineTotal + doctrineLevelItem;
												airLvl3Total = doctrineLevelItem;
											end
											
											if j == 19 and rightGroup then
												airDoctrineCost = (airDoctrineTotal + 1) * 30 + (airDoctrineTotal * 20);
												if airDoctrineCost <= ExposedMembers.airXPTotalAI then
													if  airLvl1Total >= 2 * (airLvl2Total + 1) then
														selectRandomDoctrine(playerID, 'A', 2);
													elseif airLvl2Total >= 2 * (airLvl3Total + 1) then
														selectRandomDoctrine(playerID, 'A', 3);
													else
														selectRandomDoctrine(playerID, 'A', 1);
													end
												end
											
											end
									end								
				end
		end
end
Events.PlayerTurnActivated.Add( OnPlayerTurnActivated );

function Doctrine_OnLoadScreenClose()
	print('LOADING DOCTRINE BUTTON');
	  local button2Info = {
		-- ICON TEXTURE
		IconTexture = {
		  OffsetX = 0;
		  OffsetY = 0;
		  Sheet = "LaunchBar_Hook_Doctrine.dds";
		  --Color = UI.GetColorValue("COLOR_PLAYER_BARBARIAN_PRIMARY");
		};

		-- BASE TEXTURE (Treat it as Button Texture)
		BaseTexture = {
		  OffsetX = 0;
		  OffsetY = 0;
		  Sheet = "LaunchBar_Hook_DoctrineButton.dds";
		  -- Color = UI.GetColorValue("COLOR_BLUE");
		  HoverOffsetX = 0;
		  HoverOffsetY = 49;
		};

		-- BUTTON INFO
		Callback = function() LuaEvents.DoctrineOpenManager() end;
		Tooltip = "Doctrines[NEWLINE][NEWLINE]View and choose your military doctrines.";
	  }

	 LuaEvents.LaunchBar_AddIcon(button2Info);
 end
 Events.LoadScreenClose.Add(Doctrine_OnLoadScreenClose);


function Initialize()

	-- Doctrines
	--Controls.DoctrinesButton:RegisterCallback( Mouse.eMouseEnter, function() UI.PlaySound("Main_Menu_Mouse_Over"); end);
	--Controls.DoctrinesButton:RegisterCallback(Mouse.eLClick, OnOpenDoctrines);
	Controls.CloseDoctrines:RegisterCallback(Mouse.eLClick, OnCloseDoctrines);
	Controls.ButtonInfantryDoctrine:RegisterCallback(Mouse.eLClick, OnInfantryDoctrine);
	Controls.ButtonCavalryDoctrine:RegisterCallback(Mouse.eLClick, OnCavalryDoctrine);
	Controls.ButtonReconDoctrine:RegisterCallback(Mouse.eLClick, OnReconDoctrine);
	Controls.ButtonNavalDoctrine:RegisterCallback(Mouse.eLClick, OnNavalDoctrine);
	Controls.ButtonAirDoctrine:RegisterCallback(Mouse.eLClick, OnAirDoctrine);
	Controls.ButtonRangedDoctrine:RegisterCallback(Mouse.eLClick, OnRangedDoctrine);

	LuaEvents.DoctrineOpenManager.Add(OnOpenDoctrines)
	Events.LocalPlayerTurnEnd.Add(OnCloseDoctrines)
	ContextPtr:SetInputHandler( OnInputHandler, true );

	ExposedMembers.DoctrinesScreenStatus = false;

end
Initialize();
